



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Supervisor的作用与配置</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Supervisor的作用与配置</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 00:10:03 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<div>
<h1><a href="http://www.supervisord.org/index.html" rel="external nofollow noreferrer">supervisor</a></h1>
<p>supervisor管理进程，是通过fork/exec的方式将这些被管理的进程当作supervisor的子进程来启动，所以我们只需要将要管理进程的可执行文件的路径添加到supervisor的配置文件中就好了。此时被管理进程被视为supervisor的子进程，若该子进程异常中断，则父进程可以准确的获取子进程异常中断的信息，通过在配置文件中设置autostart=ture，可以实现对异常中断的子进程的自动重启。</p>
<hr />
<h3>安装supervisor</h3>
<pre class="prettyprint linenums"><code>$ sudo apt-get install supervisor<br />
</code></pre>
<hr />
<h3>配置文件</h3>
<p>安装完supervisor后，输入以下命令可得到配置文件：</p>
<pre class="prettyprint linenums"><code>$ echo_supervisord_conf<br />
</code></pre>
<p>或者：</p>
<pre class="prettyprint linenums"><code>$ cat /etc/supervisord/supervisord.conf<br />
</code></pre>
<p>配置文件如下（分号；表示注释）：</p>
<pre class="prettyprint linenums"><code>; supervisor config file

[unix_http_server]<br />
file=/var/run/supervisor.sock   ; (the path to the socket file)<br />
chmod=0700                       ; sockef file mode (default 0700)

[supervisord]<br />
logfile=/var/log/supervisor/supervisord.log ; (main log file;default $CWD/supervisord.log)<br />
pidfile=/var/run/supervisord.pid ; (supervisord pidfile;default supervisord.pid)<br />
childlogdir=/var/log/supervisor            ; ('AUTO' child log dir, default $TEMP)

; the below section must remain in the config file for RPC<br />
; (supervisorctl/web interface) to work, additional interfaces may be<br />
; added by defining them in separate rpcinterface: sections<br />
[rpcinterface:supervisor]<br />
supervisor.rpcinterface_factory = supervisor.rpcinterface:make_main_rpcinterface

[supervisorctl]<br />
serverurl=unix:///var/run/supervisor.sock ; use a unix:// URL  for a unix socket

; The [include] section can just contain the "files" setting.  This<br />
; setting can list multiple files (separated by whitespace or<br />
; newlines).  It can also contain wildcards.  The filenames are<br />
; interpreted as relative to this file.  Included files *cannot*<br />
; include files themselves.

[include]<br />
files = /etc/supervisor/conf.d/*.conf<br />
</code></pre>
<p>以上配置文件用到几个部分：</p>
<ul><li>[unix_http_server]：这部分设置HTTP服务器监听的UNIX domain socket</p>
<ul><li>file: 指向UNIX domain socket，即file=/var/run/supervisor.sock</li>
<li>chmod：启动时改变supervisor.sock的权限</li></ul></li>
<li>[supervisord]：与supervisord有关的全局配置需要在这部分设置
<ul><li>logfile: 指向记录supervisord进程的log文件</li>
<li>pidfile：pidfile保存子进程的路径</li>
<li>childlogdir：子进程log目录设为AUTO的log目录</li></ul></li>
<li>[supervisorctl]：
<ul><li>serverurl：进入supervisord的URL， 对于UNIX domain sockets, 应设为 unix:///absolute/path/to/file.sock</li></ul></li>
<li>[include]：如果配置文件包含该部分，则该部分必须包含一个files键：
<ul><li>files：包含一个或多个文件，这里包含了/etc/supervisor/conf.d/目录下所有的.conf文件，可以在该目录下增加我们自己的配置文件，在该配置文件中增加[program:x]部分，用来运行我们自己的程序，如下：</li></ul></li>
<li>[program:x]：配置文件必须包括至少一个program，x是program名称，必须写上，不能为空
<ul><li>command：包含一个命令，当这个program启动时执行</li>
<li>directory：执行子进程时supervisord暂时切换到该目录</li>
<li>user：账户名</li>
<li>startsecs：进程从STARING状态转换到RUNNING状态program所需要保持运行的时间（单位：秒）</li>
<li>redirect_stderr：如果是true，则进程的stderr输出被发送回其stdout文件描述符上的supervisord</li>
<li>stdout_logfile：将进程stdout输出到指定文件</li>
<li>stdout_logfile_maxbytes：stdout_logfile指定日志文件最大字节数，默认为50MB，可以加KB、MB或GB等单位</li>
<li>stdout_logfile_backups：要保存的stdout_logfile备份的数量</li></ul></li></ul>
<p>示例如下，在目录/etc/supervisor/conf.d/下创建awesome.conf，并加入：</p>
<pre class="prettyprint linenums"><code>；/etc/supervisor/conf.d/awesome.conf

[program:awesome]

command     = /usr/bin/env python3 /srv/awesome/www/app.py<br />
directory   = /srv/awesome/www<br />
user        = www-data<br />
startsecs   = 3

redirect_stderr         = true<br />
stdout_logfile_maxbytes = 50MB<br />
stdout_logfile_backups  = 10<br />
stdout_logfile          = /srv/awesome/log/app.log<br />
</code></pre>
<p>配置完后，先进入/srv/awesome/目录下创建log目录，之后启动supervisor：</p>
<pre class="prettyprint linenums"><code>$ sudo supervisord -c supervisor.conf<br />
</code></pre>
<hr />
<p>supervisor基本命令（后四个命令可以省略&ldquo;-c supervisor.conf&rdquo;）：</p>
<pre class="prettyprint linenums"><code>supervisord -c supervisor.conf                       通过配置文件启动supervisor<br />
supervisorctl -c supervisor.conf status              查看状态<br />
supervisorctl -c supervisor.conf reload              重新载入配置文件<br />
supervisorctl -c supervisor.conf start [all]|[x]     启动所有/指定的程序进程<br />
supervisorctl -c supervisor.conf stop [all]|[x]      关闭所有/指定的程序进程<br />
</code></pre>
<p>执行服务（运行app.py）：</p>
<pre class="prettyprint linenums"><code>$ sudo supervisorctl start awesome<br />
</code></pre>
<p>如果supervisor遇到错误，可以在/var/log/supervisor/supervisord.log中查看日志；<br />
如果app运行出现问题，可以在/srv/awesome/log/app.log中查看日志。</p>
</div>
<p>作者：涵仔睡觉<br />链接：https://www.jianshu.com/p/0226b7c59ae2<br />来源：简书<br />简书著作权归作者所有，任何形式的转载都请联系作者获得授权并注明出处。</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/390elnqd.html">redis大幅性能提升之使用管道（PipeLine）和批量（Batch）操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/49g3w4lq.html">Java 集合系列04之 fail-fast总结&lpar;通过ArrayList来说明fail-fast的原理、解决办法&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdeol2j9.html">DWZ &lpar;JUI&rpar; 教程 国际化问题&lpar;多语言&sol;语言切换&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vyv1m8.html">linux 安装oracle 11g</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xy16m8.html">android游戏物理引擎开发&mdash;&mdash;粒子系统（三）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjk36l8.html">&lbrack;033&rsqb; 微信公众帐号开发教程第9篇-QQ表情的发送与接收（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdkmed9.html">WebRequest调用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zdjnn9.html">【转】JS容器拖拽效果，并通过cookie保存拖拽各容器的所在位置</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz4nnl8.html">ViewPager切换动画PageTransformer的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo5d01q.html">sql语句中select&hellip;&hellip;as的用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlllxr1q.html">必须要会的 50 个 React 面试题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyeym39.html">35&period;Spring-jdbc支持&period;md</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyl5yd9.html">20145203盖泽双 《网络对抗技术》实践九：Web安全基础实践</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r0r1j9.html">ListView优化中的细节问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j130p49.html">MATLAB图片折腾1</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy5wed9.html">Expo大作战&lpar;十四&rpar;--expo中消息推送的实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/93ppkyz8.html">svn解决不能clean的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zk22m18.html">python学习笔记&mdash;&mdash;高阶函数map&lpar;&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qveyglj9.html">UVA 455（最小周期）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1v3pj5q.html">c&num; 获取程序目录</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8zo53j1q.html">&lbrack;05-01&rsqb;Linux如何重启系统</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjrg2k8.html">Kali 开启 SSH 服务方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/9genrdl8.html">layui   根据后台传来的值选择按钮</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eyp60z9.html">Android 崩溃优化</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gen6g78.html">mysql 处理utf8mb4的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zpv0x9.html">linux 消息队列</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mw0lm8.html">19&period;C&num; 泛型</a>
			</li>
						<li><a href="https://www.batexi.com/a/8meo6zrq.html">Python操作MongoDB看这一篇就够了</a>
			</li>
						<li><a href="https://www.batexi.com/a/93y01k08.html">安利一个vps&comma;7美元&sol;年。</a>
			</li>
						<li><a href="https://www.batexi.com/a/95051vm8.html">爬虫---爬虫er与反爬虫er之间的斗争   转发</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
